a, button {
    color: $color-anchor;
    text-decoration: none;
    cursor: pointer;

    &:focus {
        outline: none;
    }

    &:hover {
        text-decoration: underline;
    }
}

button {
    background: inherit;
    border: none;
}

.btn {
    cursor: pointer;
    font-family: $font-primary;
    line-height: 2.4rem;
    padding: 0.9rem 3.6rem 1.1rem;
    font-size: 1.6rem;
    -webkit-appearance: none;
    -webkit-user-select: none;
    -moz-user-select: none;
    -ms-user-select: none;
    user-select: none;
    border-radius: 0;
    position: relative;
    display: inline-block;

    .text {
        display: flex;
        justify-content: center;
        align-items: center;
    }

    .spinner {
        width: 3rem;
        height: 3rem;
        position: absolute;
        top: 50%;
        left: 50%;
        transform: translate(-50%, -50%);

        svg {
            width: 3rem;
            height: 3rem;
        }
    }

    &:hover {
        text-decoration: none;
        transition: background-color 0.2s ease-out, color 0.2s ease-out, border 0.2s ease-out;
    }

    &.disabled:hover, &.waiting:hover {
        cursor: default;
    }

    &.waiting .text {
        opacity: 0;
    }

    &.btn--primary {
        color: $primary-btn-color-text;
        background-color: $primary-btn-color;

        &:hover, &:focus {
            background-color: $primary-btn-color-hover;
        }

        &:active, &.waiting, &.waiting:hover {
            background-color: $primary-btn-color-active;
        }

        &.disabled, .disabled:hover, .disabled:active, .disabled:focus {
            background-color: $primary-btn-color-disabled;
            color: $primary-btn-color-disabled-text;
        }

        .spinner .path {
            stroke: $primary-btn-color-text;
        }
    }

    &.btn--secondary {
        border: 1px solid $secondary-btn-color-border;
        padding: 0.8rem 3.5rem 1rem;
        color: $secondary-btn-color-text;

        &:hover, &:focus {
            background-color: $secondary-btn-color-hover;
        }

        &:active, &.waiting, &.waiting:hover {
            background-color: $secondary-btn-color-active;
        }

        &.disabled, &.disabled:hover, &.disabled:active, .disabled:focus {
            background-color: $secondary-btn-color-disabled;
            color: $secondary-btn-color-disabled-text;
        }

        .spinner .path {
            stroke: $secondary-btn-color-text;
        }
    }

    &.btn--quiet {
        color: $quiet-btn-color-text;

        &:hover, &:focus {
            background-color: $quiet-btn-color-hover;
        }

        &:active, &.waiting, &.waiting:hover {
            background-color: $quiet-btn-color-active;
        }

        &.disabled, &.disabled:hover, &.disabled:active, .disabled:focus {
            background-color: transparent;
            color: $quiet-btn-color-disabled-text;
        }

        .spinner .path {
            stroke: $quiet-btn-color-text;
        }
    }

    &.btn--alert {
        border: 1px solid $alert-btn-color-border;
        padding: 0.8rem 3.5rem 1rem;
        color: $alert-btn-color-text;
        background-color: $alert-btn-color;

        &:hover, &:focus {
            background-color: $alert-btn-color-hover;
        }

        &:active, &.waiting, &.waiting:hover {
            background-color: $alert-btn-color-active;
        }

        &.disabled, .disabled:hover, .disabled:active, .disabled:focus {
            background-color: $alert-btn-color-disabled;
            color: $alert-btn-color-disabled-text;
        }

        .spinner .path {
            stroke: $alert-btn-color-text;
        }
    }

    &.btn--circle {
        border-radius: 50%;
        height: 4.4rem;
        width: 4.4rem;
        padding: 0;
    }

    &.btn--pill {
        font-family: $font-primary;
        border-radius: 9999px;
        font-size: 1.6rem;
        padding: 0.6rem 2.4rem;

        &.btn--secondary, &.btn--alert {
            padding: 0.5rem 2.3rem;
        }
    }
    
    .icon--link {
        position: absolute;
        right: 1.2rem;
        width: 1.2rem;
        height: 1.2rem;

        svg {
            width: 1.2rem;
            height: 1.2rem;
        }
    }
}

.close-button {
    padding: 1rem;
    cursor: pointer;
    display: flex;
    justify-content: center;
    align-items: center;

    .icon {
        width: 2.4rem;
        height: 2.4rem;
    }
}

.floating-action-btn {
    position: fixed;
    right: 0.9rem;
    bottom: 2.4rem;
    z-index: 9999;
    visibility: hidden;
    opacity: 0;
    transition: opacity 0.2s ease-out;

    &.visible {
        visibility: visible;
        opacity: 1;
    }

    .btn--circle {
        box-shadow: 0 1px 4px 0 $color-shadow-dark;
    }

    .floating-action-btn--trigger {
        height: 5rem;
        width: 5rem;
        position: relative;
        z-index: 99;
        font-size: 2rem;
    }

    .floating-action-btn--sub-btns {
        position: absolute;
        padding: 0;
        margin: 0;
        list-style: none;
        left: 0.2rem;
        bottom: 0.2rem;

        li {
            position: absolute;

            .btn--circle {
                width: 4.6rem;
                height: 4.6rem;
                background-color: white;
                color: black;
            }
        }
    }
}
